# SPDX-License-Identifier: MPL-2.0
from collections.abc import Iterable

from llvmlite.ir import IRBuilder, Value
from numba.core.base import BaseContext

class PythonAPI:
    def __init__(self, context: BaseContext, builder: IRBuilder) -> None: ...
    def incref(self, value: Value) -> None: ...
    def decref(self, value: Value) -> None: ...
    def serialize_object(self, obj: object) -> Value: ...
    def unserialize(self, structptr: Value) -> Value: ...
    def object_getattr_string(self, obj: Value, attr: str) -> Value: ...
    def call_function_objargs(self, func: Value, args: Iterable[Value]) -> Value: ...
